var Drev = require( 'drev' ).Drev;

var fn = module.exports = {

  assassin: function ( options ) {
    options = options || {};

    var redis = options.redis || '127.0.0.1:6379';

    try{
      var redis_pieces = redis.split(':'),
          host = redis_pieces[0],
          port = Number( redis_pieces[1] );
    } catch (e) {
      throw new Error('Invalid redis URL ' + options.redis);
    }

    var min, max, total;

    if ( options.connections ) {
      min = options.connections;
      max = options.connections;
    }

    min = min || Math.max( options.min_connections || 1, 1 );
    max = max || Math.max( options.max_connections || 100, min );
    total = options.max_events;

    var persec = options.events_per_second || 100;
    
    return assassin( host, port, min, max, total, persec );
  }

};

var CYCLES_PER_SECOND = 4;

function assassin ( host, port, min, max, total, persec ) {

  var connections = [],
      id = 1,
      count = min,
      drev;

  while ( connections.length < max ) {
    drev = new Drev();
    if ( connections.length < min ) {
      drev.start(host, port);
    }
    connections.push([ drev, ( connections.length < min ) ]);
  }

  function find ( connected ) {
    for ( var i = 0; i < max; i++ ){
      if ( connections[ i ][ 1 ] === connected ) {
        return connections[ i ][ 0 ];
      }
    }
    return null;
  }

  function exit () {
    if ( total ) {
      console.log( 'Emitted %d events', total );
    }
    if ( inter ) {
      clearInterval( inter );
    }
    for ( var i = 0; i < max; i++ ) {
      if ( connections[ i ][ 1 ] ) {
        connections[ i ][ 0 ].stop();
      }
    }
  }

  var do_later = 0, done = 0;

  function mayhem () {
    var events = persec / CYCLES_PER_SECOND,
        partial = events - Math.floor( events ),
        whole = events - partial;

    do_later += partial;

    var partial_later = do_later - Math.floor( do_later ),
        whole_later = do_later - partial_later;

    whole += whole_later;
    do_later = partial_later;

    if ( ( min !== max ) && whole && ( Math.random() > .5 ) ) {
      var dir = Math.random() > .5 ? 1 : -1,
          newCount = count + dir;
      if ( newCount >= min && newCount <= max ) {
        count = newCount;
        if ( dir === -1 ) {
          find( true ).stop();
        } else {
          find( false ).start( port, host );
        }
      }
    }

    for ( var i = 0, e; i < whole; ) {
      e = Math.floor( Math.random() * connections.length );
      if ( connections[ e ][ 1 ] ) {
        connections[ e ][ 0 ].emit('mayhem', 'MAYHEM');
        done++;
        i++;
        if ( total && ( done >= total ) ) {
          exit();
          break;
        }
      }
    }
  }

  var inter;

  return {
    start: function () {
      inter = setInterval( mayhem, 1000 / CYCLES_PER_SECOND );
    },
    stop: function () {
      if ( inter ) {
        clearInterval( inter );
      }
    }
  };
  
};
